/* Process model C form file: rapp.pr.c */
/* Portions of this file copyright 1992, 1996 by MIL 3, Inc. */



/* OPNET system definitions */
#include <opnet.h>
#include "/disk2/gduan/./qosip/host_rapp/rapp.pr.h"
FSM_EXT_DECS



/* Header block */
#define TRACE 	if(0)

#include<string.h>

#define PK_ARRIVAL op_intrpt_type() == OPC_INTRPT_STRM
#define JOIN_TER  (op_intrpt_type() == OPC_INTRPT_SELF && op_intrpt_code() == 0 )
#define SEND_DATA  (op_intrpt_type() == OPC_INTRPT_SELF && op_intrpt_code() == 1 )

#define CUMM_RAPP_PKT_SENT_STAT	0

#define RSVP_STREAM		0
#define IGMP_STREAM		1
#define IP_STREAM		2

#define join_term_intr  0
#define send_data_intr  1

#define InLIST_SIZE		100

#define ON				1
#define OFF				0

#define TRUE				1
#define FALSE				0

#define SESSION_MSG		100
#define SENDER_MSG		101
#define RESERVE_MSG		102
#define RELEASE_MSG		103
#define DATA_MSG		104

#define MULTICAST			500
#define DEFAULT_DEST_PORT	80
#define DEFAULT_SRC_PORT	80
#define DEFAULT_SEND_TTL	10
#define DEFAULT_SEND_BW		60000
#define DEFAULT_SEND_DELAY	1
#define DEFAULT_RECV_BW		50000
#define DEFAULT_RECV_DELAY	1

#define UDP_PROTOCOL_ID 20
#define MAX_INIT_TIME   10
#define MAX_ATTEMPTS	5


#define VL 	if(ON)
#define SVL 	if(OFF)
#define RADL 	if(OFF)

#define PROBE_ON 	if(ON)
 
#define MAX_NO_SESSIONS		50
/*
**  IP Address
*/
typedef struct {
    int NetNum;
    int NodeNum;
}IPAddress;

typedef struct{
	IPAddress Address;
	int	Port;
}SenderInfo;

SenderInfo AllSendersList[InLIST_SIZE];
 
/*
** Data Packet Structure
*/
typedef struct{
    IPAddress SrcAddress;
    char    Data[500];
}SendDataPk;

typedef struct {
	IPAddress SenderAddr;
	IPAddress DestAddr;
	int SenderPort;
	double Bandwidth;
	double Delay;
}sd;

sd SessDirectory[MAX_NO_SESSIONS];

typedef struct {
	char Message[500];
}App_Data;

double NoOfRappPktsSent;
#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	Objid                   		sv_MyObjId;
	Objid                   		sv_RsvpObjId;
	Objid                   		sv_IpObjId;
	int                     		sv_InStrm;
	int                     		sv_GrpId;
	int                     		sv_Sess;
	int                     		sv_NoOfGrps;
	int                     		sv_StartGrp;
	int                     		sv_CurrSessionId;
	int                     		sv_SessionId;
	int                     		sv_data_len;
	int                     		sv_IsSender;
	int                     		sv_IsReceiver;
	int                     		sv_RegSes[InLIST_SIZE];
	double                  		sv_Time;
	double                  		sv_DataRecv;
	double                  		sv_SessMin;
	double                  		sv_SessMax;
	double                  		sv_DataIat;
	double                  		sv_SessIat;
	Distribution*           		sv_GrpDist;
	Distribution*           		sv_TimeDist;
	Distribution*           		sv_TermDist;
	IPAddress               		sv_LocalAddress[InLIST_SIZE];
	} rapp_state;

#define pr_state_ptr            		((rapp_state*) SimI_Mod_State_Ptr)
#define MyObjId                 		pr_state_ptr->sv_MyObjId
#define RsvpObjId               		pr_state_ptr->sv_RsvpObjId
#define IpObjId                 		pr_state_ptr->sv_IpObjId
#define InStrm                  		pr_state_ptr->sv_InStrm
#define GrpId                   		pr_state_ptr->sv_GrpId
#define Sess                    		pr_state_ptr->sv_Sess
#define NoOfGrps                		pr_state_ptr->sv_NoOfGrps
#define StartGrp                		pr_state_ptr->sv_StartGrp
#define CurrSessionId           		pr_state_ptr->sv_CurrSessionId
#define SessionId               		pr_state_ptr->sv_SessionId
#define data_len                		pr_state_ptr->sv_data_len
#define IsSender                		pr_state_ptr->sv_IsSender
#define IsReceiver              		pr_state_ptr->sv_IsReceiver
#define RegSes                  		pr_state_ptr->sv_RegSes
#define Time                    		pr_state_ptr->sv_Time
#define DataRecv                		pr_state_ptr->sv_DataRecv
#define SessMin                 		pr_state_ptr->sv_SessMin
#define SessMax                 		pr_state_ptr->sv_SessMax
#define DataIat                 		pr_state_ptr->sv_DataIat
#define SessIat                 		pr_state_ptr->sv_SessIat
#define GrpDist                 		pr_state_ptr->sv_GrpDist
#define TimeDist                		pr_state_ptr->sv_TimeDist
#define TermDist                		pr_state_ptr->sv_TermDist
#define LocalAddress            		pr_state_ptr->sv_LocalAddress

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	rapp_state *op_sv_ptr = pr_state_ptr;




/* Process model interrupt handling procedure */



void
rapp ()
	{
	Packet* IgmpApplPkptr;
	Packet* RsvpApplPkptr;
	Packet* DataApplPkptr;
	Packet* pkptr;
	
	int RecvMsgType;
	int RecvGrpId;
	int RecvSessionId;
	
	int DataAddr1, DataAddr2, DataAddr3;
	FILE* fileptr;
	
	int _block_origin = 0;


	FSM_ENTER (rapp)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (Init) enter executives **/
		FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "Init", "rapp () [Init enter execs]")
			{
			/*********************************************************************************************************
			** Process Model : rapp                                                                                 **
			** State         : Init                                                                                 **
			** Authors       : Lava K Lavu (llavu@nac.gmu.edu)                                                      **
			**                                                                                                      **
			** This state gets the object id of  the IP module and IP address of this host using that object id. It **
			** also loads all the attributes from the configuration file, and all the distributions that are needed **
			** fro selecting the group id's, session inter-arrival-time and session duration. This module generates **
			** multicast traffic which requests for the resources(only bandwidth is considered in this application) **
			** It also schedules the interrupts when this application needs to join a session initially.            **
			**                                                                                                      **
			*********************************************************************************************************/
			
			/*
			** Get the object id of this module, and using this object id load all the attributes specified in the 
			** configuration file. 
			*/
			MyObjId = op_id_self();
			
			
			op_ima_obj_attr_get( MyObjId, "RESVNGRPS", &NoOfGrps );
			op_ima_obj_attr_get( MyObjId, "STARTGRP", &StartGrp );
			op_ima_obj_attr_get( MyObjId, "SESSMIN", &SessMin );
			op_ima_obj_attr_get( MyObjId, "SESSMAX", &SessMax );
			op_ima_obj_attr_get( MyObjId, "DATA_IAT", &DataIat );
			op_ima_obj_attr_get( MyObjId, "SESS_IAT", &SessIat );
			op_ima_obj_attr_get( MyObjId, "Sender", &IsSender );
			op_ima_obj_attr_get( MyObjId, "Receiver", &IsReceiver );
			
			printf("Rapp dataIat = %f", DataIat);
			/* Add by DG for  11/19 */
			StartGrp = 11;
			
			/*
			** Get the object id of the RSVP and IP modules and using this object id get the IP address of the host
			*/
			RsvpObjId = op_topo_assoc( MyObjId, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, RSVP_STREAM );
			IpObjId = op_topo_assoc( MyObjId, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, IP_STREAM );
			op_ima_obj_attr_get( IpObjId, "net_num0", &LocalAddress[0].NetNum );
			op_ima_obj_attr_get( IpObjId, "node_num0", &LocalAddress[0].NodeNum );
			
			VL RADL printf("RAPP: LOCAL ADDRESS : %d.%d. SENDER = %d, RECEIVER = %d\n", 
					   LocalAddress[0].NetNum, LocalAddress[0].NodeNum, IsSender, IsReceiver );
			
			/* 
			** Load the statistic distributions that are used to select the group id, session inter arrival time, 
			** session duration.
			*/
			/*GrpDist = op_dist_load( "uniform_int",StartGrp,NoOfGrps );*/   /*RV in range of start and max no. groups */
			/*TimeDist = op_dist_load( "exponential",SessIat,0 );*/           /*Session inter arrival time        */
			/*TermDist = op_dist_load( "uniform",SessMin,SessMax );*/
			
			/*added by Jiemei*/
			GrpDist=op_dist_load("uniform_int",11,NoOfGrps);
			TimeDist=op_dist_load("exponential",SessIat,0);
			TermDist=op_dist_load("uniform",SessMin, SessMax);
			
			
			
			/*
			** Schedule an interrupt for joining a multicast session. This is done 10 secs after the simulation so
			** that the application doesn't join  any sessions before all intial routing tables of all the routers
			** are calculated
			*/
			/* if (LocalAddress[0].NetNum == 1) */
			/*	op_intrpt_schedule_self( (op_sim_time() + MAX_INIT_TIME), join_term_intr );
			if ( IsSender )
				op_intrpt_schedule_self( (op_sim_time() + MAX_INIT_TIME + DataIat), send_data_intr ); */
			Sess = 0;
			DataRecv = 0;
			NoOfRappPktsSent = 0;
			}


		/** state (Init) exit executives **/
		FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "Init", "rapp () [Init exit execs]")
			{
			}


		/** state (Init) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (Idle) enter executives **/
		FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "Idle", "rapp () [Idle enter execs]")
			{
			
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (3,rapp)


		/** state (Idle) exit executives **/
		FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "Idle", "rapp () [Idle exit execs]")
			{
			}


		/** state (Idle) transition processing **/
		FSM_INIT_COND (PK_ARRIVAL)
		FSM_TEST_COND (JOIN_TER)
		FSM_TEST_COND (SEND_DATA)
		FSM_TEST_LOGIC ("Idle")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;)
			FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (Arr) enter executives **/
		FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "Arr", "rapp () [Arr enter execs]")
			{
			/****************************************************************************************************
			** Process Model : rapp                                                                            **
			** State         : Arr                                                                             **
			**                                                                                                 **
			** Transition to this state from Idle state occurs when there is a packet arrival. The packet that **
			** is expected  in this state is session upcall sent by the RSVP daemon running on  the host. This **
			** carries the session id of the session that the application inteneds  to join and all references **
			** to this session s done through that session id. Upon receiving this upcall and if the upcall is **
			** session msg then the session id in that upcall is assigned to the session.                      **
			**                                                                                                 **
			****************************************************************************************************/
			
			/* 
			** Get the input stream from which the packet has arrived. Also get the packet 
			*/
			InStrm = op_intrpt_strm();
			RsvpApplPkptr = op_pk_get( op_intrpt_strm() );
			
			switch(InStrm)
			{
				/*
				** If the input stream is from the RSVP module 
				*/
				case RSVP_STREAM :
					op_pk_nfd_get( RsvpApplPkptr, "UpcallType", &RecvMsgType );
			
					/*
					** If the received message is session msg, then get the session id and make it the current
					** session's session id.
					*/
					if( RecvMsgType == SESSION_MSG )
					{
						op_pk_nfd_get( RsvpApplPkptr, "SessionId", &RecvSessionId );
						VL RADL printf("(%d.%d) Get Session Id is %d\n", 
								LocalAddress[0].NetNum, LocalAddress[0].NodeNum,
								RecvSessionId);
						RegSes[RecvSessionId] = 1;
						CurrSessionId = RecvSessionId;
					}
			    break;
			    default :
			        VL  printf("Packet has arrived from wrong input stream\n");
			    break;
			 
			}
			op_pk_destroy( RsvpApplPkptr );
			}


		/** state (Arr) exit executives **/
		FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "Arr", "rapp () [Arr exit execs]")
			{
			}


		/** state (Arr) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (Join) enter executives **/
		FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "Join", "rapp () [Join enter execs]")
			{
			/***********************************************************************************************************
			** Process Model : rapp                                                                                   **
			** State         : Join                                                                                   **
			**                                                                                                        **
			** Transition to this state from Idle state occurs when it is time for this application for joining a new **
			** session or leave the currently enrolled session. If the appliaction is not registered to any multicast **
			** group, then select a random group  make a sessioncall to the local RSVP daemon asking for a session id **
			** to this session. After  receiving the session id and if the application is a sender send a sender call **
			** to the local RSVP daemon, send a join call to IGMP module and schedule interrupts for sending data and **
			** terminating this sesion after certain time. If the application is receiver then send a receive call to **
			** the local  RSVP daemon. If the application is active in a paricular session then send a terminate call **
			** to the IGMP module, and release call to the local RSVP daemon. Schedule interrupt for joining to a new **
			** session.                                                                                               **
			** This simulation is done for a single sender Fixed-Filter style of RSVP. All the session information is **
			** logged into a  directory called  Session Directory (sd) which global  for all the applications. So the **
			** sender when it want to send data to a particular group checks this sd and if some other application is **
			** sending data to the group it selects another group for sending data. Also  the receiver when sending a **
			** receive call to the local RSVP daemon checks if there are any senders for that particular group and if **
			** they are no senders it selects another group.                                                          **
			**                                                                                                        **
			***********************************************************************************************************/
			
			TRACE	printf(" Join: The simulation time %f",op_sim_time());
			TRACE	printf("   MyObjId %d",op_id_self());
			
			/*
			** If the application is not currently enrolled in any session.
			*/
			VL RADL  printf("RAPP: (%d.%d) Join-Term  Time:%f\n",
					LocalAddress[0].NetNum, LocalAddress[0].NodeNum, op_sim_time());
			
			if(!Sess)
			{
				int SendOk, ReceiveOk, i;
				SendOk = ReceiveOk = FALSE;
				i = 0;
			
				GrpId = op_dist_outcome( GrpDist );    /*              Select a group to join                      */
			TRACE printf("  Group ID: %d\n", GrpId);
			/*	GrpId=11; */
			
				/*
				** Check if there is any application sending data for that group. If there is an applicaiion sending
				** data for  this group id, select a  different one. This process is  repeated for only MAX_ATTEMPTS 
				** times so that the application will not hang here in the worst case(when there are senders for all
				** the groups.
				*/
				while( i < MAX_ATTEMPTS )
				{
					if( IsSender )
					{
			TRACE printf("SessDerectory[%d].Senderaddr.NetNum=%d NodeNum=%d ",GrpId,SessDirectory[10].SenderAddr.NetNum,SessDirectory[10].SenderAddr.NodeNum);
						if( SessDirectory[GrpId].SenderAddr.NetNum <= 0 || 
							SessDirectory[GrpId].SenderAddr.NodeNum < 0 )
						{
							SendOk = TRUE;
			TRACE  printf("(%d.%d) S",LocalAddress[0].NetNum,LocalAddress[0].NodeNum);
							break;
						}
						else
							GrpId = op_dist_outcome( GrpDist );
					}
					if( IsReceiver )
					{
						if( SessDirectory[GrpId].SenderAddr.NetNum > 0 &&
							SessDirectory[GrpId].SenderAddr.NodeNum >= 0 )
						{
							ReceiveOk = TRUE;
			TRACE printf("(%d.%d) R",LocalAddress[0].NetNum,LocalAddress[0].NodeNum);
							break;
						}
						else 
							GrpId = op_dist_outcome( GrpDist );
					}
					i++;
				}
			
			/*	GrpId=11; */
			
				if( SendOk == TRUE || ReceiveOk == TRUE )
				{
					/*
					** If  there is no session id  assigned to the current session, make a  session call to the RSVP 
					** daemon for a session id.
					*/
			
			VL RADL printf("CurrsessionId : %d\n",CurrSessionId);
					if(CurrSessionId == 0)
					{
						/*
						** Create the session packet and fill all the fields
						*/
						Packet* SessionPkptr;
						SessionPkptr = op_pk_create_fmt("SessionCall");
						op25_pk_nfd_set( SessionPkptr, "SessionId", 0 );
						op25_pk_nfd_set( SessionPkptr, "DestNode", GrpId );
						op25_pk_nfd_set( SessionPkptr, "DestNet", MULTICAST );
						op25_pk_nfd_set( SessionPkptr, "DestPort", DEFAULT_DEST_PORT );
						data_len=op_pk_total_size_get(SessionPkptr);   /*added by Jiemei mar 21, 1997*/
			
						/*
						** Create an upcall to RSVP daemon packet and fill the fields
						*/
						RsvpApplPkptr = op_pk_create_fmt("RSVP_APP_CNTRL");
						op25_pk_nfd_set( RsvpApplPkptr, "AppCall", SessionPkptr );
						op_pk_bulk_size_set(RsvpApplPkptr,data_len); /* added by jiemei Mar 21,1997*/
						op25_pk_nfd_set( RsvpApplPkptr, "ApplCallType", SESSION_MSG );
			
						/*
						** Send the upcall to the local RSVP daemon
						*/
						op_pk_send( RsvpApplPkptr, RSVP_STREAM );  
					}
			
					/*
					** If the application is a sender and session id is given to the current session then send a sender
					** call to  RSVP daemon and join call to IGMP daemon. Log the information of the session in session
					** directory.
					*/
					if(IsSender && CurrSessionId > 0)
					{
						/*
						** Create the sender upcall and fill all the fields.
						*/
						Packet* SenderPkptr;
						SenderPkptr = op_pk_create_fmt("SenderCall");
						op25_pk_nfd_set( SenderPkptr, "SessionId", CurrSessionId );
						op25_pk_nfd_set( SenderPkptr, "SourceNet", LocalAddress[0].NetNum );
						op25_pk_nfd_set( SenderPkptr, "SourceNode", LocalAddress[0].NodeNum );
						op25_pk_nfd_set( SenderPkptr, "SourcePort", DEFAULT_SRC_PORT );
						op25_pk_nfd_set( SenderPkptr, "ttl", DEFAULT_SEND_TTL );
						op25_pk_nfd_set( SenderPkptr, "BandWidth", DEFAULT_SEND_BW );
						op25_pk_nfd_set( SenderPkptr, "Delay", DEFAULT_SEND_DELAY );
						data_len=op_pk_total_size_get(SenderPkptr); /* added by Jiemei Mar. 21 1997*/
			
						/*
						** Update the session directory
						*/
						SessDirectory[GrpId].SenderAddr = LocalAddress[0];
						SessDirectory[GrpId].SenderPort = DEFAULT_SRC_PORT;
						SessDirectory[GrpId].DestAddr.NetNum = MULTICAST;
						SessDirectory[GrpId].DestAddr.NodeNum = GrpId;
						SessDirectory[GrpId].Bandwidth = DEFAULT_SEND_BW;
						SessDirectory[GrpId].Delay = DEFAULT_SEND_DELAY;
			
			VL printf("RAPP: %fs (%d.%d) Sender join Group: %d, Session: %d\n", 
					op_sim_time(), LocalAddress[0].NetNum, LocalAddress[0].NodeNum,
					GrpId, CurrSessionId );
			
						/*
						** Create the RSVP upcall, encapsulate the sender call in it and send it to local RSVP daemon
						*/
						RsvpApplPkptr = op_pk_create_fmt("RSVP_APP_CNTRL");
						op25_pk_nfd_set( RsvpApplPkptr, "AppCall", SenderPkptr );
						op_pk_bulk_size_set(RsvpApplPkptr,data_len);  /*added by Jiemei Mar 21 1997*/
						op25_pk_nfd_set( RsvpApplPkptr, "ApplCallType", SENDER_MSG );
						op_pk_send( RsvpApplPkptr, RSVP_STREAM );
			
						Sess = 1; 	    /*     Indicate that the application is currently enrolled in a session     */
			
						/*
						** Create and IGMP application packet, fill the fields so that they represent the join packet 
						** and send it the local IGMP module 
						*/
						IgmpApplPkptr = op_pk_create_fmt("MC_APP_CNTRL");
						op25_pk_nfd_set( IgmpApplPkptr, "join", 1 );
						op25_pk_nfd_set( IgmpApplPkptr, "terminate", 0 );
						op25_pk_nfd_set( IgmpApplPkptr, "GRP_ID", GrpId );
						op_pk_send( IgmpApplPkptr, IGMP_STREAM );  
			
						/*
						** Schedule an interrupt to send data packets
						*/
						/* added by Jiemei*/
			/* commented by DG, 11/27/97, move to init_stat, same reason as in RAPP
						op_intrpt_schedule_self( (op_sim_time() + DataIat), send_data_intr ); */
					}
			
					/*
					** If the  application is a receiver and session id is given to the current session  then send a 
					** reserve call to  RSVP daemon and join call to IGMP daemon. Information of the session will be
					** in session directory.
					*/
					if( IsReceiver && CurrSessionId > 0 )
					{
						/*
						** Create the reserve upcall and fill all the fields with the values that can accessed from
						** the session directory.
						*/
						Packet* ReservePkptr;
						ReservePkptr = op_pk_create_fmt("ReserveCall");
						op25_pk_nfd_set( ReservePkptr, "SessionId", CurrSessionId );
						op25_pk_nfd_set( ReservePkptr, "SenderNode", SessDirectory[GrpId].SenderAddr.NodeNum );
						op25_pk_nfd_set( ReservePkptr, "SenderNet", SessDirectory[GrpId].SenderAddr.NetNum );
						op25_pk_nfd_set( ReservePkptr, "SenderPort", SessDirectory[GrpId].SenderPort );
						op25_pk_nfd_set( ReservePkptr, "BandWidth", SessDirectory[GrpId].Bandwidth );
						op25_pk_nfd_set( ReservePkptr, "Delay", SessDirectory[GrpId].Delay );
						data_len=op_pk_total_size_get(ReservePkptr); /*added by Jiemei Mar 21 1997*/
						/*
						** Create the RSVP upcall, encapsulate  the reserve call into it and send the upcall to the
						** local RSVP daemon
						*/
						RsvpApplPkptr = op_pk_create_fmt("RSVP_APP_CNTRL");
						op25_pk_nfd_set( RsvpApplPkptr, "AppCall", ReservePkptr );
						op_pk_bulk_size_set(RsvpApplPkptr,data_len); /* added by Jiemei Mar 21 1997*/
						op25_pk_nfd_set( RsvpApplPkptr, "ApplCallType", RESERVE_MSG );
						op_pk_send( RsvpApplPkptr, RSVP_STREAM );
			
						Sess = 1;       /*     Indicate that the application is currently enrolled in a session     */
			VL printf("RAPP: %fs (%d.%d) receiver join Group: %d, Session: %d\n", 
					op_sim_time(), LocalAddress[0].NetNum, LocalAddress[0].NodeNum,
					GrpId, CurrSessionId );
			
						/*
						** Create and IGMP application packet, fill the fields so that they represent the join packet 
						** and send it the local IGMP module 
						*/
						IgmpApplPkptr = op_pk_create_fmt("MC_APP_CNTRL");
						op25_pk_nfd_set( IgmpApplPkptr, "join", 1 );
						op25_pk_nfd_set( IgmpApplPkptr, "terminate", 0 );
						op25_pk_nfd_set( IgmpApplPkptr, "GRP_ID", GrpId );
						op_pk_send( IgmpApplPkptr, IGMP_STREAM );  
					}
			
				}
				/*
				** Schedule an interrupt for termianting this session
				*/
			 if ( Sess )	/* DG, 11/20 for debug */
			 {
				Time = op_dist_outcome( TermDist );    
				op_intrpt_schedule_self( op_sim_time()+Time, join_term_intr);
			 } else {
				Time = op_dist_outcome( TimeDist );   
				op_intrpt_schedule_self( op_sim_time()+Time, join_term_intr);
			 }
			TRACE	printf("  Termdist %f\n",Time);  /* added by Jiemei*/  
			
			}
			/*
			** If it  is currently enrolled in  a multicast  session, then terminate  that session and  schedule an 
			** interrupt for joining to a new session
			*/
			else
			{
				/*
				** Create  the release upcall and  pass the session id of the session that it wants to terminate
				*/
				Packet* ReleasePkptr;
				ReleasePkptr = op_pk_create_fmt("ReleaseCall");
				op25_pk_nfd_set( ReleasePkptr, "SessionId", CurrSessionId );
				data_len=op_pk_total_size_get(ReleasePkptr);  /*added by Jiemei Mar 21 1997*/
				/* 
				** Create the Rsvp upcall, encapsulate the Release call into it and send the upcall to the local 
				** RSVP module.
				*/
				RsvpApplPkptr = op_pk_create_fmt("RSVP_APP_CNTRL");
				op25_pk_nfd_set( RsvpApplPkptr, "AppCall", ReleasePkptr );
				op_pk_bulk_size_set(RsvpApplPkptr,data_len); /*added by Jiemei mar 21 1997*/
				op25_pk_nfd_set( RsvpApplPkptr, "ApplCallType", RELEASE_MSG );
				op_pk_send( RsvpApplPkptr, RSVP_STREAM ); 
			
			VL printf("RAPP: %fs (%d.%d) release Group: %d\n", 
					op_sim_time(), LocalAddress[0].NetNum, LocalAddress[0].NodeNum, GrpId );
				/*
				** Create and IGMP  application packet, fill the fields so that they represent  the terminate packet
				** and send it the local IGMP module
				*/
				IgmpApplPkptr = op_pk_create_fmt( "MC_APP_CNTRL" );
				op25_pk_nfd_set( IgmpApplPkptr, "join", 0 );
				op25_pk_nfd_set( IgmpApplPkptr, "terminate", 1 );
				op25_pk_nfd_set( IgmpApplPkptr, "GRP_ID", GrpId );
				op_pk_send( IgmpApplPkptr, IGMP_STREAM );   
				VL	RADL	printf( "Sending the terminate packet to the IGMP Layer \n" );   
				
			
			/* Added by DG, 11/18, clear currSessionId and SessDir so that it could join another session next time. */
				CurrSessionId = 0;
				if ( IsSender )
					SessDirectory[GrpId].SenderAddr.NetNum = 0;
			
			
				Sess = 0; 		/*     Indicate that the application is currently not registered to any session   */
			
				/*
				** Schedule an interrupt for joining to a new session
				*/
				Time = op_dist_outcome( TimeDist );   
				op_intrpt_schedule_self( op_sim_time()+Time, 0);
			}
			}


		/** state (Join) exit executives **/
		FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "Join", "rapp () [Join exit execs]")
			{
			}


		/** state (Join) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (Data_Send) enter executives **/
		FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "Data_Send", "rapp () [Data_Send enter execs]")
			{
			/*******************************************************************************************************
			** Process Model : rapp                                                                               **
			** State         : Data_Send                                                                          **
			**                                                                                                    **
			** Check if the host is currently registered with a session, and if it is send an data packet to that **
			** session. Size of the  data packet is 500 bytes. This data packet is encapsulated into an IP packet **
			** and sent to IP module. The destination net in the IP packet is set to the multicast address( 500 ) **
			** and the destination node in the  IP packet is set to multicast Group ID  of the session that it is **
			** currently registered to. Interrupt is scheduled to send the next data packet.                      **
			**                                                                                                    **
			*******************************************************************************************************/
			
			if( Sess && IsSender )
			{ 
			
				App_Data* DataSent;   /*changed by Jiemei, Mar 27 97*/
				Packet* ip_pkptr;
			
				/* changed by Jiemei, MAr 27, 97*/
				DataSent=(App_Data *) op_prg_mem_alloc(sizeof(App_Data));
				sprintf( DataSent->Message, "RAPP  %f Src %d %d Dest %d %d\n", op_sim_time(),
			             LocalAddress[0].NetNum, LocalAddress[0].NodeNum, 500, GrpId );
			
				/*
				** Create the data packet format and stuff the data into the packet pointer
				*/
				pkptr = op_pk_create_fmt("Unicast_Appl");
			    	op25_pk_nfd_set(pkptr, "UniData", DataSent, op_prg_mem_alloc, op_prg_mem_free, sizeof(App_Data) );
			    	data_len = op_pk_total_size_get( pkptr )/8;
			
				/*
				** Encapsulate the data packet into the IP datagram by filling the data packet pointer sender 
				** address, destination group, data length protocol ID and the time-to-live fields.
				*/
			    	ip_pkptr = op_pk_create_fmt("ip_dgram");
			    	op25_pk_nfd_set(ip_pkptr, "data", pkptr );
			    	op25_pk_nfd_set(ip_pkptr, "prot_id", UDP_PROTOCOL_ID );
			    	op_pk_bulk_size_set(ip_pkptr, data_len*8 );
				op25_pk_nfd_set(ip_pkptr, "dest_net", 500 );
				op25_pk_nfd_set(ip_pkptr, "dest_node", GrpId );
				op25_pk_nfd_set(ip_pkptr, "src_net", LocalAddress[0].NetNum );
			    	op25_pk_nfd_set(ip_pkptr, "src_node", LocalAddress[0].NodeNum );
				op25_pk_nfd_set(ip_pkptr, "orig_len", data_len );
			    	op25_pk_nfd_set(ip_pkptr, "frag_len", data_len );
			    	op25_pk_nfd_set(ip_pkptr, "ttl", 9 );  /* changed by Jiemei from 2 to 8 */
			    	op25_pk_nfd_set(ip_pkptr, "frag", 0 );
			
				VL 
				{
					printf("RAPP %fs (%d.%d) send packet to %d group\n", 
						op_sim_time(),
						LocalAddress[0].NetNum, LocalAddress[0].NodeNum, GrpId );
				}
			
				/*
				** Write the number of data packets that are sent by this module to a probe
				*/
				PROBE_ON
				{
					NoOfRappPktsSent++;
					op_stat_local_write( CUMM_RAPP_PKT_SENT_STAT, NoOfRappPktsSent);
				}
			
				op_pk_send(ip_pkptr, IP_STREAM);     /*      Send the data packet to the IP module         */
			}
			
			/* 
			** Schedule an interrupt for the next data packet 
			*/
			op_intrpt_schedule_self( (op_sim_time() + DataIat), send_data_intr );
			}


		/** state (Data_Send) exit executives **/
		FSM_STATE_EXIT_FORCED (4, state4_exit_exec, "Data_Send", "rapp () [Data_Send exit execs]")
			{
			}


		/** state (Data_Send) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (0,rapp)
	}




void
rapp_svar (prs_ptr,var_name,var_p_ptr)
	rapp_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (rapp_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;
	if (Vos_String_Equal ("MyObjId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_MyObjId);
	if (Vos_String_Equal ("RsvpObjId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_RsvpObjId);
	if (Vos_String_Equal ("IpObjId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_IpObjId);
	if (Vos_String_Equal ("InStrm" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_InStrm);
	if (Vos_String_Equal ("GrpId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_GrpId);
	if (Vos_String_Equal ("Sess" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_Sess);
	if (Vos_String_Equal ("NoOfGrps" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_NoOfGrps);
	if (Vos_String_Equal ("StartGrp" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_StartGrp);
	if (Vos_String_Equal ("CurrSessionId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_CurrSessionId);
	if (Vos_String_Equal ("SessionId" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_SessionId);
	if (Vos_String_Equal ("data_len" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_len);
	if (Vos_String_Equal ("IsSender" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_IsSender);
	if (Vos_String_Equal ("IsReceiver" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_IsReceiver);
	if (Vos_String_Equal ("RegSes" , var_name))
		*var_p_ptr = (char *) (prs_ptr->sv_RegSes);
	if (Vos_String_Equal ("Time" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_Time);
	if (Vos_String_Equal ("DataRecv" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_DataRecv);
	if (Vos_String_Equal ("SessMin" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_SessMin);
	if (Vos_String_Equal ("SessMax" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_SessMax);
	if (Vos_String_Equal ("DataIat" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_DataIat);
	if (Vos_String_Equal ("SessIat" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_SessIat);
	if (Vos_String_Equal ("GrpDist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_GrpDist);
	if (Vos_String_Equal ("TimeDist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_TimeDist);
	if (Vos_String_Equal ("TermDist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_TermDist);
	if (Vos_String_Equal ("LocalAddress" , var_name))
		*var_p_ptr = (char *) (prs_ptr->sv_LocalAddress);

	FOUT;
	}




void
rapp_diag ()
	{
	Packet* IgmpApplPkptr;
	Packet* RsvpApplPkptr;
	Packet* DataApplPkptr;
	Packet* pkptr;
	
	int RecvMsgType;
	int RecvGrpId;
	int RecvSessionId;
	
	int DataAddr1, DataAddr2, DataAddr3;
	FILE* fileptr;
	
	int _block_origin;

	FIN (rapp_diag ())

	BINIT

	FOUT;
	}




void
rapp_terminate ()
	{
	Packet* IgmpApplPkptr;
	Packet* RsvpApplPkptr;
	Packet* DataApplPkptr;
	Packet* pkptr;
	
	int RecvMsgType;
	int RecvGrpId;
	int RecvSessionId;
	
	int DataAddr1, DataAddr2, DataAddr3;
	FILE* fileptr;
	
	int _block_origin;

	FIN (rapp_terminate ())

	BINIT

	FOUT;
	}



Compcode
rapp_init (pr_state_pptr)
	rapp_state			**pr_state_pptr;
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	extern int				Vos_Nop ();

	FIN (rapp_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (rapp)",
			sizeof (rapp_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (rapp_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 0;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



enum { _block_origin = __LINE__ };

